# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_03_01
  module Models
    #
    # The system automatically scales the cluster up and down (within
    # minimumNodeCount and maximumNodeCount) based on the pending and running
    # jobs on the cluster.
    #
    class AutoScaleSettings

      include MsRestAzure

      # @return [Integer] Specifies the minimum number of compute nodes the
      # cluster can have.
      attr_accessor :minimum_node_count

      # @return [Integer] Specifies the maximum number of compute nodes the
      # cluster can have.
      attr_accessor :maximum_node_count

      # @return [Integer] Specifies the number of compute nodes to allocate on
      # cluster creation. Note that this value is used only during cluster
      # creation. . Default value: 0 .
      attr_accessor :initial_node_count


      #
      # Mapper for AutoScaleSettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AutoScaleSettings',
          type: {
            name: 'Composite',
            class_name: 'AutoScaleSettings',
            model_properties: {
              minimum_node_count: {
                client_side_validation: true,
                required: true,
                serialized_name: 'minimumNodeCount',
                type: {
                  name: 'Number'
                }
              },
              maximum_node_count: {
                client_side_validation: true,
                required: true,
                serialized_name: 'maximumNodeCount',
                type: {
                  name: 'Number'
                }
              },
              initial_node_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'initialNodeCount',
                default_value: 0,
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
