# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_05_01
  module Models
    #
    # Properties of the file or directory.
    #
    class File

      include MsRestAzure

      # @return [String] Name. Name of the file.
      attr_accessor :name

      # @return [FileType] File type. Type of the file. Possible values are
      # file and directory. Possible values include: 'file', 'directory'
      attr_accessor :file_type

      # @return [String] Download URL. URL to download the corresponding file.
      # The downloadUrl is not returned for directories.
      attr_accessor :download_url

      # @return [DateTime] Last modified time. The time at which the file was
      # last modified.
      attr_accessor :last_modified

      # @return [Integer] Content length. The file of the size.
      attr_accessor :content_length


      #
      # Mapper for File class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'File',
          type: {
            name: 'Composite',
            class_name: 'File',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              file_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'fileType',
                type: {
                  name: 'String'
                }
              },
              download_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'downloadUrl',
                type: {
                  name: 'String'
                }
              },
              last_modified: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastModified',
                type: {
                  name: 'DateTime'
                }
              },
              content_length: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.contentLength',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
