# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_05_01
  module Models
    #
    # Details of volumes to mount on the cluster.
    #
    class MountVolumes

      include MsRestAzure

      # @return [Array<AzureFileShareReference>] Azure File Shares. A
      # collection of Azure File Shares that are to be mounted to the cluster
      # nodes.
      attr_accessor :azure_file_shares

      # @return [Array<AzureBlobFileSystemReference>] Azure Blob file systems.
      # A collection of Azure Blob Containers that are to be mounted to the
      # cluster nodes.
      attr_accessor :azure_blob_file_systems

      # @return [Array<FileServerReference>] File Servers. A collection of
      # Batch AI File Servers that are to be mounted to the cluster nodes.
      attr_accessor :file_servers

      # @return [Array<UnmanagedFileSystemReference>] Unmanaged file systems. A
      # collection of unmanaged file systems that are to be mounted to the
      # cluster nodes.
      attr_accessor :unmanaged_file_systems


      #
      # Mapper for MountVolumes class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'MountVolumes',
          type: {
            name: 'Composite',
            class_name: 'MountVolumes',
            model_properties: {
              azure_file_shares: {
                client_side_validation: true,
                required: false,
                serialized_name: 'azureFileShares',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AzureFileShareReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'AzureFileShareReference'
                      }
                  }
                }
              },
              azure_blob_file_systems: {
                client_side_validation: true,
                required: false,
                serialized_name: 'azureBlobFileSystems',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AzureBlobFileSystemReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'AzureBlobFileSystemReference'
                      }
                  }
                }
              },
              file_servers: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fileServers',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'FileServerReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'FileServerReference'
                      }
                  }
                }
              },
              unmanaged_file_systems: {
                client_side_validation: true,
                required: false,
                serialized_name: 'unmanagedFileSystems',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UnmanagedFileSystemReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UnmanagedFileSystemReference'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
